<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/serde_derive-1.0.140/src/internals/receiver.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>receiver.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../serde_derive/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../serde_derive/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">internals::respan::respan</span>;
<span class="kw">use</span> <span class="ident">proc_macro2::Span</span>;
<span class="kw">use</span> <span class="ident">quote::ToTokens</span>;
<span class="kw">use</span> <span class="ident">std::mem</span>;
<span class="kw">use</span> <span class="ident">syn::punctuated::Punctuated</span>;
<span class="kw">use</span> <span class="ident">syn</span>::{
    <span class="ident">parse_quote</span>, <span class="ident">Data</span>, <span class="ident">DeriveInput</span>, <span class="ident">Expr</span>, <span class="ident">ExprPath</span>, <span class="ident">GenericArgument</span>, <span class="ident">GenericParam</span>, <span class="ident">Generics</span>, <span class="ident">Macro</span>,
    <span class="ident">Path</span>, <span class="ident">PathArguments</span>, <span class="ident">QSelf</span>, <span class="ident">ReturnType</span>, <span class="ident">Type</span>, <span class="ident">TypeParamBound</span>, <span class="ident">TypePath</span>, <span class="ident">WherePredicate</span>,
};

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">replace_receiver</span>(<span class="ident">input</span>: <span class="kw-2">&amp;mut</span> <span class="ident">DeriveInput</span>) {
    <span class="kw">let</span> <span class="ident">self_ty</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="ident">ident</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">input</span>.<span class="ident">ident</span>;
        <span class="kw">let</span> <span class="ident">ty_generics</span> <span class="op">=</span> <span class="ident">input</span>.<span class="ident">generics</span>.<span class="ident">split_for_impl</span>().<span class="number">1</span>;
        <span class="macro">parse_quote!</span>(#<span class="ident">ident</span> #<span class="ident">ty_generics</span>)
    };
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">visitor</span> <span class="op">=</span> <span class="ident">ReplaceReceiver</span>(<span class="kw-2">&amp;</span><span class="ident">self_ty</span>);
    <span class="ident">visitor</span>.<span class="ident">visit_generics_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">input</span>.<span class="ident">generics</span>);
    <span class="ident">visitor</span>.<span class="ident">visit_data_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">input</span>.<span class="ident">data</span>);
}

<span class="kw">struct</span> <span class="ident">ReplaceReceiver</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">TypePath</span>);

<span class="kw">impl</span> <span class="ident">ReplaceReceiver</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">self_ty</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">span</span>: <span class="ident">Span</span>) -&gt; <span class="ident">TypePath</span> {
        <span class="kw">let</span> <span class="ident">tokens</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">to_token_stream</span>();
        <span class="kw">let</span> <span class="ident">respanned</span> <span class="op">=</span> <span class="ident">respan</span>(<span class="ident">tokens</span>, <span class="ident">span</span>);
        <span class="ident">syn::parse2</span>(<span class="ident">respanned</span>).<span class="ident">unwrap</span>()
    }

    <span class="kw">fn</span> <span class="ident">self_to_qself</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">qself</span>: <span class="kw-2">&amp;mut</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">QSelf</span><span class="op">&gt;</span>, <span class="ident">path</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Path</span>) {
        <span class="kw">if</span> <span class="ident">path</span>.<span class="ident">leading_colon</span>.<span class="ident">is_some</span>() <span class="op">|</span><span class="op">|</span> <span class="ident">path</span>.<span class="ident">segments</span>[<span class="number">0</span>].<span class="ident">ident</span> <span class="op">!</span><span class="op">=</span> <span class="string">&quot;Self&quot;</span> {
            <span class="kw">return</span>;
        }

        <span class="kw">if</span> <span class="ident">path</span>.<span class="ident">segments</span>.<span class="ident">len</span>() <span class="op">==</span> <span class="number">1</span> {
            <span class="self">self</span>.<span class="ident">self_to_expr_path</span>(<span class="ident">path</span>);
            <span class="kw">return</span>;
        }

        <span class="kw">let</span> <span class="ident">span</span> <span class="op">=</span> <span class="ident">path</span>.<span class="ident">segments</span>[<span class="number">0</span>].<span class="ident">ident</span>.<span class="ident">span</span>();
        <span class="kw-2">*</span><span class="ident">qself</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">QSelf</span> {
            <span class="ident">lt_token</span>: <span class="macro">Token!</span>[<span class="op">&lt;</span>](<span class="ident">span</span>),
            <span class="ident">ty</span>: <span class="ident">Box::new</span>(<span class="ident">Type::Path</span>(<span class="self">self</span>.<span class="ident">self_ty</span>(<span class="ident">span</span>))),
            <span class="ident">position</span>: <span class="number">0</span>,
            <span class="ident">as_token</span>: <span class="prelude-val">None</span>,
            <span class="ident">gt_token</span>: <span class="macro">Token!</span>[<span class="op">&gt;</span>](<span class="ident">span</span>),
        });

        <span class="ident">path</span>.<span class="ident">leading_colon</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="kw-2">*</span><span class="kw-2">*</span><span class="ident">path</span>.<span class="ident">segments</span>.<span class="ident">pairs</span>().<span class="ident">next</span>().<span class="ident">unwrap</span>().<span class="ident">punct</span>().<span class="ident">unwrap</span>());

        <span class="kw">let</span> <span class="ident">segments</span> <span class="op">=</span> <span class="ident">mem::replace</span>(<span class="kw-2">&amp;mut</span> <span class="ident">path</span>.<span class="ident">segments</span>, <span class="ident">Punctuated::new</span>());
        <span class="ident">path</span>.<span class="ident">segments</span> <span class="op">=</span> <span class="ident">segments</span>.<span class="ident">into_pairs</span>().<span class="ident">skip</span>(<span class="number">1</span>).<span class="ident">collect</span>();
    }

    <span class="kw">fn</span> <span class="ident">self_to_expr_path</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">path</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Path</span>) {
        <span class="kw">let</span> <span class="ident">self_ty</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">self_ty</span>(<span class="ident">path</span>.<span class="ident">segments</span>[<span class="number">0</span>].<span class="ident">ident</span>.<span class="ident">span</span>());
        <span class="kw">let</span> <span class="ident">variant</span> <span class="op">=</span> <span class="ident">mem::replace</span>(<span class="ident">path</span>, <span class="ident">self_ty</span>.<span class="ident">path</span>);
        <span class="kw">for</span> <span class="ident">segment</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">path</span>.<span class="ident">segments</span> {
            <span class="kw">if</span> <span class="kw">let</span> <span class="ident">PathArguments::AngleBracketed</span>(<span class="ident">bracketed</span>) <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">segment</span>.<span class="ident">arguments</span> {
                <span class="kw">if</span> <span class="ident">bracketed</span>.<span class="ident">colon2_token</span>.<span class="ident">is_none</span>() <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">bracketed</span>.<span class="ident">args</span>.<span class="ident">is_empty</span>() {
                    <span class="ident">bracketed</span>.<span class="ident">colon2_token</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="op">&lt;</span><span class="macro">Token!</span>[::]<span class="op">&gt;</span><span class="ident">::default</span>());
                }
            }
        }
        <span class="kw">if</span> <span class="ident">variant</span>.<span class="ident">segments</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">1</span> {
            <span class="ident">path</span>.<span class="ident">segments</span>.<span class="ident">push_punct</span>(<span class="op">&lt;</span><span class="macro">Token!</span>[::]<span class="op">&gt;</span><span class="ident">::default</span>());
            <span class="ident">path</span>.<span class="ident">segments</span>.<span class="ident">extend</span>(<span class="ident">variant</span>.<span class="ident">segments</span>.<span class="ident">into_pairs</span>().<span class="ident">skip</span>(<span class="number">1</span>));
        }
    }
}

<span class="kw">impl</span> <span class="ident">ReplaceReceiver</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="comment">// `Self` -&gt; `Receiver`</span>
    <span class="kw">fn</span> <span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">ty</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Type</span>) {
        <span class="kw">let</span> <span class="ident">span</span> <span class="op">=</span> <span class="kw">if</span> <span class="kw">let</span> <span class="ident">Type::Path</span>(<span class="ident">node</span>) <span class="op">=</span> <span class="ident">ty</span> {
            <span class="kw">if</span> <span class="ident">node</span>.<span class="ident">qself</span>.<span class="ident">is_none</span>() <span class="op">&amp;&amp;</span> <span class="ident">node</span>.<span class="ident">path</span>.<span class="ident">is_ident</span>(<span class="string">&quot;Self&quot;</span>) {
                <span class="ident">node</span>.<span class="ident">path</span>.<span class="ident">segments</span>[<span class="number">0</span>].<span class="ident">ident</span>.<span class="ident">span</span>()
            } <span class="kw">else</span> {
                <span class="self">self</span>.<span class="ident">visit_type_path_mut</span>(<span class="ident">node</span>);
                <span class="kw">return</span>;
            }
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">visit_type_mut_impl</span>(<span class="ident">ty</span>);
            <span class="kw">return</span>;
        };
        <span class="kw-2">*</span><span class="ident">ty</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">self_ty</span>(<span class="ident">span</span>).<span class="ident">into</span>();
    }

    <span class="comment">// `Self::Assoc` -&gt; `&lt;Receiver&gt;::Assoc`</span>
    <span class="kw">fn</span> <span class="ident">visit_type_path_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">ty</span>: <span class="kw-2">&amp;mut</span> <span class="ident">TypePath</span>) {
        <span class="kw">if</span> <span class="ident">ty</span>.<span class="ident">qself</span>.<span class="ident">is_none</span>() {
            <span class="self">self</span>.<span class="ident">self_to_qself</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">qself</span>, <span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">path</span>);
        }
        <span class="self">self</span>.<span class="ident">visit_type_path_mut_impl</span>(<span class="ident">ty</span>);
    }

    <span class="comment">// `Self::method` -&gt; `&lt;Receiver&gt;::method`</span>
    <span class="kw">fn</span> <span class="ident">visit_expr_path_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">expr</span>: <span class="kw-2">&amp;mut</span> <span class="ident">ExprPath</span>) {
        <span class="kw">if</span> <span class="ident">expr</span>.<span class="ident">qself</span>.<span class="ident">is_none</span>() {
            <span class="self">self</span>.<span class="ident">self_to_qself</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">qself</span>, <span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">path</span>);
        }
        <span class="self">self</span>.<span class="ident">visit_expr_path_mut_impl</span>(<span class="ident">expr</span>);
    }

    <span class="comment">// Everything below is simply traversing the syntax tree.</span>

    <span class="kw">fn</span> <span class="ident">visit_type_mut_impl</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">ty</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Type</span>) {
        <span class="kw">match</span> <span class="ident">ty</span> {
            <span class="ident">Type::Array</span>(<span class="ident">ty</span>) =&gt; {
                <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">elem</span>);
                <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">len</span>);
            }
            <span class="ident">Type::BareFn</span>(<span class="ident">ty</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">arg</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">inputs</span> {
                    <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">arg</span>.<span class="ident">ty</span>);
                }
                <span class="self">self</span>.<span class="ident">visit_return_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">output</span>);
            }
            <span class="ident">Type::Group</span>(<span class="ident">ty</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">elem</span>),
            <span class="ident">Type::ImplTrait</span>(<span class="ident">ty</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">bound</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">bounds</span> {
                    <span class="self">self</span>.<span class="ident">visit_type_param_bound_mut</span>(<span class="ident">bound</span>);
                }
            }
            <span class="ident">Type::Macro</span>(<span class="ident">ty</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_macro_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">mac</span>),
            <span class="ident">Type::Paren</span>(<span class="ident">ty</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">elem</span>),
            <span class="ident">Type::Path</span>(<span class="ident">ty</span>) =&gt; {
                <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">qself</span>) <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">qself</span> {
                    <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">qself</span>.<span class="ident">ty</span>);
                }
                <span class="self">self</span>.<span class="ident">visit_path_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">path</span>);
            }
            <span class="ident">Type::Ptr</span>(<span class="ident">ty</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">elem</span>),
            <span class="ident">Type::Reference</span>(<span class="ident">ty</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">elem</span>),
            <span class="ident">Type::Slice</span>(<span class="ident">ty</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">elem</span>),
            <span class="ident">Type::TraitObject</span>(<span class="ident">ty</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">bound</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">bounds</span> {
                    <span class="self">self</span>.<span class="ident">visit_type_param_bound_mut</span>(<span class="ident">bound</span>);
                }
            }
            <span class="ident">Type::Tuple</span>(<span class="ident">ty</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">elem</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">elems</span> {
                    <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="ident">elem</span>);
                }
            }

            <span class="ident">Type::Infer</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">Type::Never</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">Type::Verbatim</span>(<span class="kw">_</span>) =&gt; {}

            <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">all</span>(<span class="ident">test</span>, <span class="ident">exhaustive</span>), <span class="ident">deny</span>(<span class="ident">non_exhaustive_omitted_patterns</span>))]</span>
            <span class="kw">_</span> =&gt; {}
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_type_path_mut_impl</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">ty</span>: <span class="kw-2">&amp;mut</span> <span class="ident">TypePath</span>) {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">qself</span>) <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">qself</span> {
            <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">qself</span>.<span class="ident">ty</span>);
        }
        <span class="self">self</span>.<span class="ident">visit_path_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">ty</span>.<span class="ident">path</span>);
    }

    <span class="kw">fn</span> <span class="ident">visit_expr_path_mut_impl</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">expr</span>: <span class="kw-2">&amp;mut</span> <span class="ident">ExprPath</span>) {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">qself</span>) <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">qself</span> {
            <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">qself</span>.<span class="ident">ty</span>);
        }
        <span class="self">self</span>.<span class="ident">visit_path_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">path</span>);
    }

    <span class="kw">fn</span> <span class="ident">visit_path_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">path</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Path</span>) {
        <span class="kw">for</span> <span class="ident">segment</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">path</span>.<span class="ident">segments</span> {
            <span class="self">self</span>.<span class="ident">visit_path_arguments_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">segment</span>.<span class="ident">arguments</span>);
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_path_arguments_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">arguments</span>: <span class="kw-2">&amp;mut</span> <span class="ident">PathArguments</span>) {
        <span class="kw">match</span> <span class="ident">arguments</span> {
            <span class="ident">PathArguments::None</span> =&gt; {}
            <span class="ident">PathArguments::AngleBracketed</span>(<span class="ident">arguments</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">arg</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">arguments</span>.<span class="ident">args</span> {
                    <span class="kw">match</span> <span class="ident">arg</span> {
                        <span class="ident">GenericArgument::Type</span>(<span class="ident">arg</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="ident">arg</span>),
                        <span class="ident">GenericArgument::Binding</span>(<span class="ident">arg</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">arg</span>.<span class="ident">ty</span>),
                        <span class="ident">GenericArgument::Lifetime</span>(<span class="kw">_</span>)
                        <span class="op">|</span> <span class="ident">GenericArgument::Constraint</span>(<span class="kw">_</span>)
                        <span class="op">|</span> <span class="ident">GenericArgument::Const</span>(<span class="kw">_</span>) =&gt; {}
                    }
                }
            }
            <span class="ident">PathArguments::Parenthesized</span>(<span class="ident">arguments</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">argument</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">arguments</span>.<span class="ident">inputs</span> {
                    <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="ident">argument</span>);
                }
                <span class="self">self</span>.<span class="ident">visit_return_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">arguments</span>.<span class="ident">output</span>);
            }
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_return_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">return_type</span>: <span class="kw-2">&amp;mut</span> <span class="ident">ReturnType</span>) {
        <span class="kw">match</span> <span class="ident">return_type</span> {
            <span class="ident">ReturnType::Default</span> =&gt; {}
            <span class="ident">ReturnType::Type</span>(<span class="kw">_</span>, <span class="ident">output</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="ident">output</span>),
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_type_param_bound_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">bound</span>: <span class="kw-2">&amp;mut</span> <span class="ident">TypeParamBound</span>) {
        <span class="kw">match</span> <span class="ident">bound</span> {
            <span class="ident">TypeParamBound::Trait</span>(<span class="ident">bound</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_path_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">bound</span>.<span class="ident">path</span>),
            <span class="ident">TypeParamBound::Lifetime</span>(<span class="kw">_</span>) =&gt; {}
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_generics_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">generics</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Generics</span>) {
        <span class="kw">for</span> <span class="ident">param</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">generics</span>.<span class="ident">params</span> {
            <span class="kw">match</span> <span class="ident">param</span> {
                <span class="ident">GenericParam::Type</span>(<span class="ident">param</span>) =&gt; {
                    <span class="kw">for</span> <span class="ident">bound</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">param</span>.<span class="ident">bounds</span> {
                        <span class="self">self</span>.<span class="ident">visit_type_param_bound_mut</span>(<span class="ident">bound</span>);
                    }
                }
                <span class="ident">GenericParam::Lifetime</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">GenericParam::Const</span>(<span class="kw">_</span>) =&gt; {}
            }
        }
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">where_clause</span>) <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">generics</span>.<span class="ident">where_clause</span> {
            <span class="kw">for</span> <span class="ident">predicate</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">where_clause</span>.<span class="ident">predicates</span> {
                <span class="kw">match</span> <span class="ident">predicate</span> {
                    <span class="ident">WherePredicate::Type</span>(<span class="ident">predicate</span>) =&gt; {
                        <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">predicate</span>.<span class="ident">bounded_ty</span>);
                        <span class="kw">for</span> <span class="ident">bound</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">predicate</span>.<span class="ident">bounds</span> {
                            <span class="self">self</span>.<span class="ident">visit_type_param_bound_mut</span>(<span class="ident">bound</span>);
                        }
                    }
                    <span class="ident">WherePredicate::Lifetime</span>(<span class="kw">_</span>) <span class="op">|</span> <span class="ident">WherePredicate::Eq</span>(<span class="kw">_</span>) =&gt; {}
                }
            }
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_data_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">data</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Data</span>) {
        <span class="kw">match</span> <span class="ident">data</span> {
            <span class="ident">Data::Struct</span>(<span class="ident">data</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">field</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">data</span>.<span class="ident">fields</span> {
                    <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">field</span>.<span class="ident">ty</span>);
                }
            }
            <span class="ident">Data::Enum</span>(<span class="ident">data</span>) =&gt; {
                <span class="kw">for</span> <span class="ident">variant</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">data</span>.<span class="ident">variants</span> {
                    <span class="kw">for</span> <span class="ident">field</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">variant</span>.<span class="ident">fields</span> {
                        <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">field</span>.<span class="ident">ty</span>);
                    }
                }
            }
            <span class="ident">Data::Union</span>(<span class="kw">_</span>) =&gt; {}
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">expr</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Expr</span>) {
        <span class="kw">match</span> <span class="ident">expr</span> {
            <span class="ident">Expr::Binary</span>(<span class="ident">expr</span>) =&gt; {
                <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">left</span>);
                <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">right</span>);
            }
            <span class="ident">Expr::Call</span>(<span class="ident">expr</span>) =&gt; {
                <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">func</span>);
                <span class="kw">for</span> <span class="ident">arg</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">args</span> {
                    <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="ident">arg</span>);
                }
            }
            <span class="ident">Expr::Cast</span>(<span class="ident">expr</span>) =&gt; {
                <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">expr</span>);
                <span class="self">self</span>.<span class="ident">visit_type_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">ty</span>);
            }
            <span class="ident">Expr::Field</span>(<span class="ident">expr</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">base</span>),
            <span class="ident">Expr::Index</span>(<span class="ident">expr</span>) =&gt; {
                <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">expr</span>);
                <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">index</span>);
            }
            <span class="ident">Expr::Paren</span>(<span class="ident">expr</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">expr</span>),
            <span class="ident">Expr::Path</span>(<span class="ident">expr</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_expr_path_mut</span>(<span class="ident">expr</span>),
            <span class="ident">Expr::Unary</span>(<span class="ident">expr</span>) =&gt; <span class="self">self</span>.<span class="ident">visit_expr_mut</span>(<span class="kw-2">&amp;mut</span> <span class="ident">expr</span>.<span class="ident">expr</span>),
            <span class="kw">_</span> =&gt; {}
        }
    }

    <span class="kw">fn</span> <span class="ident">visit_macro_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">_mac</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Macro</span>) {}
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="serde_derive" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>